//+------------------------------------------------------------------+
//|                                                    FdkLevel2.mqh |
//|                                           Copyright 2013, SoftFX |
//|                                               http://soft-fx.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, SoftFX"
#property link      "http://soft-fx.com"

//#import "Octl2Ext.ex4"
// Send request to calculate margin;
// handle - int;
// input value - should contain the result of FdkCreate function;

//void FdkSendCalculateMarginRequest(int gTrader);

// returns window size in pixels
//void GetWindowSizeInPixels(int &size[]);

// returns string size in pixels
//void GetStringSizeInPixels(string s, int &size[]);
//void GetStringSizeInPixels(uchar &s[], int &size[]);

#import "SoftFX.OneClickTrading.dll"

// Creates instance of FDK information provider;
// Returns provider guid;
// accountServer - string;
// input value - should contain the result of AccountServer() function; 

//  Fix for bild 536
//int FdkCreate(int &isServerAllowed[], string accountServer, string terminalCompany, string accountCompany);
int FdkCreate(int &isServerAllowed[], uchar &accountServer[], uchar &terminalCompany[], uchar &accountCompany[]);

// Deletes instance of FDK information provider;
// handle - int;
// input value - should contain the result of FdkCreate function;
void FdkDelete(int handle);

// Subscribes to FDK level2;
// handle - int;
// input value - should contain the result of FdkCreate function;
// symbol - string;
// input value - should contain Symbol name in "CCY1CCY2" format; 
// depth - int;
// input value - should contain a level2 depth to subscribe;

//  Fix for bild 536
// void FdkSubscribe(int handle, string symbol, int depth);
void FdkSubscribe(int handle, uchar &symbol[], int depth);

// Unsubscribes to FDK level2;
// handle - int;
// input value - should contain the result of FdkCreate function;
// symbol - string;
// input value - should contain Symbol name in "CCY1CCY2" format; 

//  Fix for bild 536
// void FdkUnsubscribe(int handle, string symbol);
void FdkUnsubscribe(int handle, uchar &symbol[]);

// Updates subscribed quotes;
// Returns count of updated quotes;
// handle - int;
// input value - should contain the result of FdkCreate function;
int FdkRefreshQuotes(int handle);

// handle - int;
// input value - should contain the result of FdkCreate function
// symbol - string;
// input value - should contain Symbol name in "CCY1CCY2" format; 
// SizeBids - 1-size array;
// input value - should contain amount of items in Bids and BidVols arrays; 
// output value - contains actual amount of filled items in Bids and BidVols after successful call;
// Bids - SizeBids[0]-size array;
// output value - contains Bid Prices after successful call;
// BidVols - SizeBids[0]-size array;
// output value - contains Bid Volumes after successful call;
// SizeAsks - 1-size array;
// input value - should contain amount of items in Asks and AskVols arrays; 
// output value - contains actual amount of filled items in Asks and AskVols after successful call;
// Asks - SizeAsks[0]-size array;
// output value - contains Ask Prices after successful call;
// AskVols - SizeAsks[0]-size array;
// output value - contains Ask Volumes after successful call;

//  Fix for bild 536
// void FdkGetQuotes(int handle, string symbol, int &SizeBids[], double &Bids[], double &BidVols[], int &SizeAsks[], double &Asks[], double &AskVols[]);
void FdkGetQuotes(int handle, uchar &symbol[], int &SizeBids[], double &Bids[], double &BidVols[], int &SizeAsks[], double &Asks[], double &AskVols[]);

// handle - int;
// input value - should contain the result of FdkCreate function
// symbol - string;
// input value - should contain Symbol name in "CCY1CCY2" format; 
// SizeBids - 1-size array;
// input value - should contain amount of items in Bids and BidVols arrays; 
// output value - contains actual amount of filled items in Bids and BidVols after successful call;
// Bids - SizeBids[0]-size array;
// output value - contains Bid Prices after successful call;
// BidVols - SizeBids[0]-size array;
// output value - contains Bid Volumes after successful call;

//  Fix for bild 536
// void FdkGetBidQuotes(int handle, string symbol, int &SizeBids[], double &Bids[], double &BidVols[]);
void FdkGetBidQuotes(int handle, uchar &symbol[], int &SizeBids[], double &Bids[], double &BidVols[]);

// handle - int;
// input value - should contain the result of FdkCreate function
// symbol - string;
// input value - should contain Symbol name in "CCY1CCY2" format; 
// SizeAsks - 1-size array;
// input value - should contain amount of items in Asks and AskVols arrays; 
// output value - contains actual amount of filled items in Asks and AskVols after successful call;
// Asks - SizeAsks[0]-size array;
// output value - contains Ask Prices after successful call;
// AskVols - SizeAsks[0]-size array;
// output value - contains Ask Volumes after successful call;

//  Fix for bild 536
//  void FdkGetAskQuotes(int handle, string symbol, int &SizeAsks[], double &Asks[], double &AskVols[]);
void FdkGetAskQuotes(int handle, uchar &symbol[], int &SizeAsks[], double &Asks[], double &AskVols[]);

// handle - int;
// input value - should contain the result of FdkCreate function
// symbol - string;
// input value - should contain Symbol name in "CCY1CCY2" format;
// BidAsk - 2-size array;
// output value;
// BidAsk[0] <-> BestBid
// BidAsk[1] <-> BestAsk

//  Fix for bild 536
// void FdkGetBestBidAsk(int handle, string symbol, double &BidAsk[]);
void FdkGetBestBidAsk(int handle, uchar &symbol[], double &BidAsk[]);

// Returns if the margin is calculated after FdkSendCalculateMarginRequest is called
// handle - int;
// input value - should contain the result of FdkCreate function
// margin - 1-size array;
// output value - contains margin after successful call otherwise zero;
// timeout - int;
// input value - should contain timeout in ms to wait for margin is calculated; 
int FdkGetMargin(int handle, double &margin[], int timeout);
#import

//void GetStringSizeInPixels(string s, int &size[])
//{
//  uchar temp[];
//  StringToCharArray(s,temp);
//  GetStringSizeInPixels(temp, size);
//}
int FdkCreate(int &isServerAllowed[], string accountServer, string terminalCompany, string accountCompany)
{
  uchar aS[], tC[], aC[];
  StringToCharArray(accountServer,aS);
  StringToCharArray(terminalCompany,tC);
  StringToCharArray(accountCompany,aC);
  return FdkCreate(isServerAllowed, aS, tC, aC);
}
void FdkSubscribe(int handle, string symbol, int depth)
{
  uchar temp[];
  StringToCharArray(symbol,temp);
  FdkSubscribe(handle, temp, depth);
}
void FdkUnsubscribe(int handle, string symbol)
{
  uchar temp[];
  StringToCharArray(symbol,temp);
  FdkUnsubscribe(handle, temp);
}
void FdkGetQuotes(int handle, string symbol, int &SizeBids[], double &Bids[], double &BidVols[], int &SizeAsks[], double &Asks[], double &AskVols[])
{
  uchar temp[];
  StringToCharArray(symbol,temp);
  FdkGetQuotes(handle, temp, SizeBids, Bids, BidVols, SizeAsks, Asks, AskVols);
}
void FdkGetBidQuotes(int handle, string symbol, int &SizeBids[], double &Bids[], double &BidVols[])
{
  uchar temp[];
  StringToCharArray(symbol,temp);
  FdkGetBidQuotes(handle, temp, SizeBids, Bids, BidVols);
}
void FdkGetAskQuotes(int handle, string symbol, int &SizeAsks[], double &Asks[], double &AskVols[])
{
  uchar temp[];
  StringToCharArray(symbol,temp);
  FdkGetBidQuotes(handle, temp, SizeAsks, Asks, AskVols);
}
void FdkGetBestBidAsk(int handle, string symbol, double &BidAsk[])
{
  uchar temp[];
  StringToCharArray(symbol,temp);
  FdkGetBestBidAsk(handle, temp, BidAsk);
}

// 
//void FdkSendCalculateMarginRequest(int gTrader)
//{
//  int FdkGetMargin(int handle, double &margin[], int timeout);
//}

void GetWindowSizeInPixels(int &size[])
{
  size[0]=800; size[1]=600;
}
void GetStringSizeInPixels(string s, int &size[])
{
  size[0]=StringLen(s)*12; size[1]=12;
}